#!/usr/bin/env python

from regions import region
from numpy import array, amin, interp

class Region(region):
    def __init__(self, rcf):
        rname = rcf.get('region')
        region.__init__(
            self,
            name=rname,
            lat0=rcf.get('region.%s.lat0'%rname), lat1=rcf.get('region.%s.lat1'%rname), dlat=rcf.get('region.%s.dlat'%rname),
            lon0=rcf.get('region.%s.lon0'%rname), lon1=rcf.get('region.%s.lon1'%rname), dlon=rcf.get('region.%s.dlon'%rname)
        )

def interpTime(t1, t0, d0):
    tt1 = array([(t-amin(t1)).total_seconds() for t in t1])
    tt0 = array([(t-amin(t1)).total_seconds() for t in t0])
    return interp(tt1, tt0, d0)