#!/usr/bin/python

from numpy import *
import tables
import datetime
import os
from nc2dict import *

def untar(tarfile, pattern, path='.', preservepath=True):
    #x = os.system("tar xvf "+tarfile+" --directory="+path+" --wildcards --no-anchored '"+pattern+"'")
    x = os.popen("tar xvf "+tarfile+" --directory=. --wildcards --no-anchored '"+pattern+"'")
    # move files to path if preservepath == False:
    if not preservepath:
        for file in x.readlines():
            file = file.strip('/').strip('\n')
            print path+'/'+file.split('/')[-1]
            shutil.move(file, path+'/'+file.split('/')[-1])
	try :
	    os.removedirs(os.path.dirname(file))
	except :
	    pass
    return

def h5todict(h5file):
    """ reads a dictionary from a hdf5 file.
        if _islist in variable attributes, variable will be converted into a list
        if _isdtime in variable attributes, variable will be converted into a datetime array (or list)"""
    def h52d(t1):
        """ this is the recursive function doing the actual parsing """
	dint = {}
	itemlist = t1.__members__
	for ii in itemlist:
	    v1 = getattr(t1,ii)
	    if type(v1) == tables.group.Group:
		dint[ii] = h52d(v1)
		if v1._v_attrs._v_attrnamesuser != [] :
                    # variable attributes
		    dint['_attrs'] = {}
		    for jj in v1._v_attrs._v_attrnamesuser:
		        dint['_attrs'][jj] = getattr(v1._v_attrs,jj)
	    else:
		dint[ii] = v1[:]
		if '_isdtime' in v1._v_attrs._v_attrnamesuser:
		    if v1._v_attrs._isdtime :
		        dint[ii] = array([datetime.datetime(*x) for x in dint[ii]])
		if '_islist' in v1._v_attrs._v_attrnamesuser:
		    if v1._v_attrs._islist :
		        dint[ii] = list(dint[ii])
        # group attributes:
        if t1._v_attrs._v_attrnamesuser:
            dint['_attrs'] = {}
            for ii in t1._v_attrs._v_attrnamesuser:
                dint['_attrs'][ii] = getattr(t1._v_attrs, ii)
	return dint
	
    f1 = tables.openFile(h5file,mode='r')
    d1 = h52d(f1.root)
    f1.close()
    return d1
    
def dict2h5(dd,fname,title='',attr=None):
    """ recursively converts a dictionary to a pytables class. Then write to hdf
        d1: current working variable
        t1: current variable name in parent dictionary
        f1: python tables class object
        g1: current working group in f1"""
    def write_attrs(g1,dattrs):
        for ii in dattrs.keys():
	    setattr(getattr(g1,'_v_attrs'),ii,dattrs[ii])
    def dict_walk(d1,t1,f1,g1):
	if type(d1) == dict :
	    if t1 == '_attrs':
	        write_attrs(g1,d1)
	    else :
	        g2 = f1.createGroup(g1,t1)
	        for ii in d1.keys():
		    dict_walk(d1[ii],ii,f1,g2)
	else :
	    # converts the data in an array writable by pyTables
	    islist,isdtime = False,False
	    if size(d1) > 0:
		if type(d1) != ndarray and size(d1) == 1:
		    d1 = array([d1])
		else :
		    if type(d1) == list : d1 = array(d1)
		if type(d1[0]) in [datetime.datetime,datetime.date]:
		    d1 = array([x.timetuple()[:6] for x in d1])
		    isdtime = True
		f1.createArray(g1,t1,d1)
		if isdtime: setattr(getattr(g1,t1)._v_attrs,'_isdtime',True)
    
    # opens the hdf file for writing
    f1 = tables.openFile(fname,mode='w',title=title)
    
    # walk on the dictionary elements:
    for ii in dd.keys():
	dict_walk(dd[ii],ii,f1,f1.root)

    # possibility of global dataset attributes ==> automatic if '_attrs' in 1st level dictionary keys.
    if attr != None :
        write_attrs(f1.root,attr)
    f1.close()

def pic2dic(picfile):
    import cPickle
    a = open(picfile,'r')
    b = cPickle.load(a)
    a.close()
    return b

def dic2pic(dic, picfile):
    import cPickle
    a = open(picfile, 'w')
    cPickle.dump(dic,a)
    a.close()
